PROGRAM=exercise_07_36
CXX=g++
CXXFLAGS=-Wall -Wextra -Werror -std=c++03 -g3

SOURCES:=$(wildcard *.cpp)
PREPROCS:=$(patsubst %.cpp, %.ii, $(SOURCES))
ASSEMBLES:=$(patsubst %.cpp, %.s, $(SOURCES))
OBJS:=$(patsubst %.cpp, %.o, $(SOURCES))

test1: $(PROGRAM)
	./$(PROGRAM) < $@.input > $@.output || echo "Negative test"
	diff $@.output $@.expected && echo PASSED || echo FAILED

$(PROGRAM): $(OBJS) | .gitignore
	$(CXX)    $(CXXFLAGS) $^ -o $@
	
%.ii: %.cpp
	$(CXX) -E $(CXXFLAGS) $< -o $@
	
%.s: %.ii
	$(CXX) -S $(CXXFLAGS) $< -o $@
	
%.o: %.s
	$(CXX) -c $(CXXFLAGS) $< -o $@
	
.gitignore:
	echo $(PROGRAM) > .gitignore
	
clean:
	rm *.s *.ii *.o $(PROGRAM) .gitignore test1.output
	
.PRECIOUS: $(PREPROCS) $(ASSEBLES)
.SECONDARY: $(PREPROCS) $(ASSEBLES)
